# This code is 2001,2002 copyrighted by Dirk Datzert <dirk@datzert.de> 
#
# It is Open Source. See the LICENSE.txt for more details!
#
# written by Dirk Datzert
# Last updated: December 28, 2001

import Globals, time
from DateTime import DateTime
from Products.OFSP.Version import manage_addVersion, Version
from string import join, split, find


try:
  from Products.ZBabel.Utils import translate
except:
  from NoBabelTag import translate

methods = { 'translate': translate }


preview_cookie = "Preview-Version"

back_cookie = "Preview-Back-Redirect"


def manage_addPreviewVersion(self, REQUEST, RESPONSE):
    ''' '''

    if REQUEST.has_key('AUTHENTICATED_USER'):
        user = REQUEST.AUTHENTICATED_USER.getId()
    else:
	self.owner_info()['id']

    t = time.time()
    id = 'version-%s-%s' % ( user, str(long(t*1000)))
    title = translate(self, "Preview version for user %s, %s" ) \
	% (user, DateTime(t).strftime('%Y-%m-%d %H:%M:%S'))

    self._setObject(id, PreviewVersion(id, title))

    version = getattr(self, id)
    version.cookie = join(version.getPhysicalPath(), '/')

    RESPONSE.setCookie ( preview_cookie, version.cookie,
    	expires = (DateTime() + 30).rfc822(),
    	path = (REQUEST['BASEPATH1'] or '/'))

    RESPONSE.setCookie ( Globals.VersionNameName, version.cookie,
	expires = (DateTime() + 30).rfc822(),
	path = (REQUEST['BASEPATH1'] or '/'))

    RESPONSE.redirect ( REQUEST['HTTP_REFERER'] )


class PreviewVersion(Version):
    ''' '''
    meta_type = 'Preview Version'

    manage_options = ( 
	Version.manage_options +
	(
	{ 'label' : 'Enter',   'action' : 'manage_enter' },
	{ 'label' : 'Leave',   'action' : 'manage_leave' },
	{ 'label' : 'Save',    'action' : 'manage_save' },
	{ 'label' : 'Discard', 'action' : 'manage_discard' }
	)
	)

    def __init__(self, id, title):
	''' '''

	self.id = id
	self.title = title
	

    def manage_enter(self, REQUEST, RESPONSE):
        ''' '''

        if self and hasattr(self, 'cookie'):
	    RESPONSE.setCookie ( Globals.VersionNameName, self.cookie,
	        expires = (DateTime() + 30).rfc822(),
	        path = (REQUEST['BASEPATH1'] or '/' ))

	    RESPONSE.setCookie ( preview_cookie, self.cookie,
    		expires = (DateTime() + 30).rfc822(),
    		path = (REQUEST['BASEPATH1'] or '/'))

	    RESPONSE.redirect ( REQUEST['HTTP_REFERER'] )

	    return

        manage_addPreviewVersion(self, REQUEST, RESPONSE)


    def manage_leave(self, REQUEST, RESPONSE):
        ''' '''

        RESPONSE.setCookie ( Globals.VersionNameName, 'No longer active',
	    expires = (DateTime() - 30).rfc822(),
	    path = (REQUEST['BASEPATH1'] or '/' ))

	RESPONSE.redirect ( REQUEST['HTTP_REFERER'] )

    def _delete(self, REQUEST, RESPONSE):
        ''' '''

	back = REQUEST['HTTP_REFERER']

	if find ( back, self.getId()) >= 0:
	    back = self.aq_parent.absolute_url() + "/manage_main"

        RESPONSE.setCookie ( back_cookie, back,
	    path = (REQUEST['BASEPATH1'] or '/' ))

        RESPONSE.redirect ( self.absolute_url() + "/manage_delete" )


    def manage_save(self, REQUEST, RESPONSE):
        ''' '''

        self.save('')

        self.manage_leave(REQUEST, RESPONSE)
        self._delete(REQUEST, RESPONSE)


    def manage_discard(self, REQUEST, RESPONSE):
        ''' '''

        self.discard()

        self.manage_leave(REQUEST, RESPONSE)
        self._delete(REQUEST, RESPONSE)


    def manage_delete(self, REQUEST, RESPONSE):
        ''' '''

	self.aq_parent.manage_delObjects(ids=self.getId())

        RESPONSE.setCookie ( preview_cookie, 'No longer active',
	    expires = (DateTime() - 30).rfc822(),
	    path = (REQUEST['BASEPATH1'] or '/' ))

        RESPONSE.setCookie ( back_cookie, 'No longer active',
	    expires = (DateTime() - 30).rfc822(),
	    path = (REQUEST['BASEPATH1'] or '/' ))

	if REQUEST.has_key(back_cookie):
            RESPONSE.redirect ( REQUEST[back_cookie] )
	else:
	    RESPONSE.redirect ( REQUEST['HTTP_REFERER'] )


Globals.default__class_init__(PreviewVersion)
